<?php 
//echo "Hola!! Webhook";
//Se usa la funcion file_get_contents() con el fin de obtener los datos del endpoint 
$data = file_get_contents('php://input');
//Se asigna una variable para almacenar el objeto 
$activity = json_decode($data);
//print_r($activity);

//Se declara las variables que se usaran en el cuerpo del mensaje.
$person_id = $activity->current->person_id; //<-- Variable encargada de almacenar el Id de la persona
$activiy_id = $activity->current->id;       //<-- Variable encargada de almacenar el Id de la actividad
$type_name =  $activity->current->type_name;//<-- Variable encargada de almacenar el tipo de actividad
$message =  $activity->current->note;       //<-- Variable encargada de almacenar contenido del mensaje 


//se declara las variables para pasarlas a la API de Pipedrive. En este caso se consultara los datos de una persona con person_id y la actualizacion de una actividad.
$token = '08bb2a57f5c64060e3e0d0356627afb3e53f68b4'; // <-- Se debe indicar el token API de Pipedrive
$urlGetPer = "https://labsmobile.pipedrive.com/v1/persons/{$person_id}?api_token={$token}";     // <-- Variable encargada de almacenar la URL para consultar a la persona con el ID
$urlPutAct = "https://labsmobile.pipedrive.com/v1/activities/{$activiy_id}?api_token={$token}"; // <-- Variable encargada de almacenar la URL para actualizar la actividad

//If para filtrar el tipo de notificacion 
if ($type_name === "SMS") {
  
  $curl = curl_init();

  curl_setopt_array($curl, array(
    CURLOPT_URL => $urlGetPer,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => '',
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 0,
    CURLOPT_FOLLOWLOCATION => true,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => array(
      'Accept: application/json',
      'Cookie: __cf_bm=.9mreT2e1G8rsIlVskv.krQekNrwZu42QQQUWwznc.4-1677780370-0-AZhfOhg8WW2y4zNrToKDkIjKX+niAnJwJgXTcdzpq2EykUIE50BxgGytmNLT87m15/w6IkgMWwuBXnPHIHwMJwA='
    ),
  ));
  
  $response = curl_exec($curl);
  
  curl_close($curl);
  //echo $response;

  //Se obtiene el objeto de numeros telefonicos del la persona
  $person = json_decode($response);
  $arrayMobile = $person->data->phone;
  //var_dump(count($arrayMobile));

  //Se itera un nuevo array para pasarlo en el body del mensaje
  for ($i=0; $i < count($arrayMobile) ; $i++) { 
    $mobile[] = array('msisdn' => $arrayMobile[$i]->value);
  }
  //var_dump($mobile);
  
  //Se crea el cuerpo del mensaje con los diferentes parametros    
  $body = array(
    "message"=> strip_tags($message),
    "tpoa"=> "Sender",
    "recipient"=> $mobile
  );
  //print_r($body);

  //Se realizar la llamada a la api de LabsMobile para el envio
  $auth_basic = base64_encode("oscar.santa@labsmobile.com:GA6lF92bE7sXGusrlBhUe512pDAjXRtt"); //<-- Se debe indicar el usuario y contraseña o usuario y token de la cuenta LasbsMobile
  $curl = curl_init();


  curl_setopt_array($curl, array(
    CURLOPT_URL => "https://api.labsmobile.com/json/send",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "POST",
    CURLOPT_POSTFIELDS => json_encode($body),
    CURLOPT_HTTPHEADER => array(
      "Authorization: Basic ".$auth_basic,
      "Cache-Control: no-cache",
      "Content-Type: application/json"
    ),
  ));

  $response = curl_exec($curl);
  $err = curl_error($curl);

  curl_close($curl);

  if ($err) {
    echo "cURL Error #:" . $err;
  } else {
    echo $response;
  }

  //Se obtiene el estado del mensaje 
  $statusSMS = json_decode($response);
  $notificacion = $statusSMS->message;
  $notificacion = array('subject' => $notificacion);

  //Actualizacion de actividad en pipedrive.
  $curl = curl_init();

  curl_setopt_array($curl, array(
    CURLOPT_URL => $urlPutAct,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => '',
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 0,
    CURLOPT_FOLLOWLOCATION => true,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => 'PUT',
    CURLOPT_POSTFIELDS => json_encode($notificacion),
    CURLOPT_HTTPHEADER => array(
      'Content-Type: application/json',
      'Accept: application/json',
      'Cookie: __cf_bm=YorCMpO5qrVSPbRXBXCEKl.FMo91nDqvtyjFtSs.t4M-1677869663-0-AZ8frpI/7I1FUlZlYoicImhiIefq3pMoFZ02c4oj1Jcbvn5cS8AMvbuX6vFDLdyP5ZU+WXfBl3HVPTEQbQjtsD0='
    ),
  ));

  $response = curl_exec($curl);

  curl_close($curl);
  //echo $response;

}else{
  echo "Se esta enviando una actividad que no es un SMS: ".$type_name;
}

?>